package de.humance.eco.profile.model.impl;

import com.liferay.portal.kernel.bean.AutoEscapeBeanHandler;
import com.liferay.portal.kernel.util.GetterUtil;
import com.liferay.portal.kernel.util.ProxyUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.model.impl.BaseModelImpl;
import com.liferay.portal.service.ServiceContext;

import com.liferay.portlet.expando.model.ExpandoBridge;
import com.liferay.portlet.expando.util.ExpandoBridgeFactoryUtil;

import de.humance.eco.profile.model.VehicleTypeResource;
import de.humance.eco.profile.model.VehicleTypeResourceModel;

import java.io.Serializable;

import java.sql.Types;

import java.util.HashMap;
import java.util.Map;

/**
 * The base model implementation for the VehicleTypeResource service. Represents a row in the &quot;Profile_VehicleTypeResource&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This implementation and its corresponding interface {@link de.humance.eco.profile.model.VehicleTypeResourceModel} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link VehicleTypeResourceImpl}.
 * </p>
 *
 * @author Humance
 * @see VehicleTypeResourceImpl
 * @see de.humance.eco.profile.model.VehicleTypeResource
 * @see de.humance.eco.profile.model.VehicleTypeResourceModel
 * @generated
 */
public class VehicleTypeResourceModelImpl extends BaseModelImpl<VehicleTypeResource>
    implements VehicleTypeResourceModel {
    /*
     * NOTE FOR DEVELOPERS:
     *
     * Never modify or reference this class directly. All methods that expect a vehicle type resource model instance should use the {@link de.humance.eco.profile.model.VehicleTypeResource} interface instead.
     */
    public static final String TABLE_NAME = "Profile_VehicleTypeResource";
    public static final Object[][] TABLE_COLUMNS = {
            { "vehicleTypeResourceId", Types.BIGINT },
            { "vehicleTypeId", Types.BIGINT },
            { "country", Types.VARCHAR },
            { "language", Types.VARCHAR },
            { "name", Types.VARCHAR },
            { "iconId", Types.BIGINT }
        };
    public static final String TABLE_SQL_CREATE = "create table Profile_VehicleTypeResource (vehicleTypeResourceId LONG not null primary key,vehicleTypeId LONG,country VARCHAR(75) null,language VARCHAR(75) null,name VARCHAR(500) null,iconId LONG)";
    public static final String TABLE_SQL_DROP = "drop table Profile_VehicleTypeResource";
    public static final String ORDER_BY_JPQL = " ORDER BY vehicleTypeResource.vehicleTypeId ASC, vehicleTypeResource.country ASC, vehicleTypeResource.language ASC";
    public static final String ORDER_BY_SQL = " ORDER BY Profile_VehicleTypeResource.vehicleTypeId ASC, Profile_VehicleTypeResource.country ASC, Profile_VehicleTypeResource.language ASC";
    public static final String DATA_SOURCE = "liferayDataSource";
    public static final String SESSION_FACTORY = "liferaySessionFactory";
    public static final String TX_MANAGER = "liferayTransactionManager";
    public static final boolean ENTITY_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.entity.cache.enabled.de.humance.eco.profile.model.VehicleTypeResource"),
            true);
    public static final boolean FINDER_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.finder.cache.enabled.de.humance.eco.profile.model.VehicleTypeResource"),
            true);
    public static final boolean COLUMN_BITMASK_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.column.bitmask.enabled.de.humance.eco.profile.model.VehicleTypeResource"),
            true);
    public static long COUNTRY_COLUMN_BITMASK = 1L;
    public static long LANGUAGE_COLUMN_BITMASK = 2L;
    public static long VEHICLETYPEID_COLUMN_BITMASK = 4L;
    public static final long LOCK_EXPIRATION_TIME = GetterUtil.getLong(com.liferay.util.service.ServiceProps.get(
                "lock.expiration.time.de.humance.eco.profile.model.VehicleTypeResource"));
    private static ClassLoader _classLoader = VehicleTypeResource.class.getClassLoader();
    private static Class<?>[] _escapedModelInterfaces = new Class[] {
            VehicleTypeResource.class
        };
    private long _vehicleTypeResourceId;
    private long _vehicleTypeId;
    private long _originalVehicleTypeId;
    private boolean _setOriginalVehicleTypeId;
    private String _country;
    private String _originalCountry;
    private String _language;
    private String _originalLanguage;
    private String _name;
    private long _iconId;
    private long _columnBitmask;
    private VehicleTypeResource _escapedModel;

    public VehicleTypeResourceModelImpl() {
    }

    @Override
    public long getPrimaryKey() {
        return _vehicleTypeResourceId;
    }

    @Override
    public void setPrimaryKey(long primaryKey) {
        setVehicleTypeResourceId(primaryKey);
    }

    @Override
    public Serializable getPrimaryKeyObj() {
        return _vehicleTypeResourceId;
    }

    @Override
    public void setPrimaryKeyObj(Serializable primaryKeyObj) {
        setPrimaryKey(((Long) primaryKeyObj).longValue());
    }

    @Override
    public Class<?> getModelClass() {
        return VehicleTypeResource.class;
    }

    @Override
    public String getModelClassName() {
        return VehicleTypeResource.class.getName();
    }

    @Override
    public Map<String, Object> getModelAttributes() {
        Map<String, Object> attributes = new HashMap<String, Object>();

        attributes.put("vehicleTypeResourceId", getVehicleTypeResourceId());
        attributes.put("vehicleTypeId", getVehicleTypeId());
        attributes.put("country", getCountry());
        attributes.put("language", getLanguage());
        attributes.put("name", getName());
        attributes.put("iconId", getIconId());

        return attributes;
    }

    @Override
    public void setModelAttributes(Map<String, Object> attributes) {
        Long vehicleTypeResourceId = (Long) attributes.get(
                "vehicleTypeResourceId");

        if (vehicleTypeResourceId != null) {
            setVehicleTypeResourceId(vehicleTypeResourceId);
        }

        Long vehicleTypeId = (Long) attributes.get("vehicleTypeId");

        if (vehicleTypeId != null) {
            setVehicleTypeId(vehicleTypeId);
        }

        String country = (String) attributes.get("country");

        if (country != null) {
            setCountry(country);
        }

        String language = (String) attributes.get("language");

        if (language != null) {
            setLanguage(language);
        }

        String name = (String) attributes.get("name");

        if (name != null) {
            setName(name);
        }

        Long iconId = (Long) attributes.get("iconId");

        if (iconId != null) {
            setIconId(iconId);
        }
    }

    @Override
    public long getVehicleTypeResourceId() {
        return _vehicleTypeResourceId;
    }

    @Override
    public void setVehicleTypeResourceId(long vehicleTypeResourceId) {
        _vehicleTypeResourceId = vehicleTypeResourceId;
    }

    @Override
    public long getVehicleTypeId() {
        return _vehicleTypeId;
    }

    @Override
    public void setVehicleTypeId(long vehicleTypeId) {
        _columnBitmask = -1L;

        if (!_setOriginalVehicleTypeId) {
            _setOriginalVehicleTypeId = true;

            _originalVehicleTypeId = _vehicleTypeId;
        }

        _vehicleTypeId = vehicleTypeId;
    }

    public long getOriginalVehicleTypeId() {
        return _originalVehicleTypeId;
    }

    @Override
    public String getCountry() {
        if (_country == null) {
            return StringPool.BLANK;
        } else {
            return _country;
        }
    }

    @Override
    public void setCountry(String country) {
        _columnBitmask = -1L;

        if (_originalCountry == null) {
            _originalCountry = _country;
        }

        _country = country;
    }

    public String getOriginalCountry() {
        return GetterUtil.getString(_originalCountry);
    }

    @Override
    public String getLanguage() {
        if (_language == null) {
            return StringPool.BLANK;
        } else {
            return _language;
        }
    }

    @Override
    public void setLanguage(String language) {
        _columnBitmask = -1L;

        if (_originalLanguage == null) {
            _originalLanguage = _language;
        }

        _language = language;
    }

    public String getOriginalLanguage() {
        return GetterUtil.getString(_originalLanguage);
    }

    @Override
    public String getName() {
        if (_name == null) {
            return StringPool.BLANK;
        } else {
            return _name;
        }
    }

    @Override
    public void setName(String name) {
        _name = name;
    }

    @Override
    public long getIconId() {
        return _iconId;
    }

    @Override
    public void setIconId(long iconId) {
        _iconId = iconId;
    }

    public long getColumnBitmask() {
        return _columnBitmask;
    }

    @Override
    public ExpandoBridge getExpandoBridge() {
        return ExpandoBridgeFactoryUtil.getExpandoBridge(0,
            VehicleTypeResource.class.getName(), getPrimaryKey());
    }

    @Override
    public void setExpandoBridgeAttributes(ServiceContext serviceContext) {
        ExpandoBridge expandoBridge = getExpandoBridge();

        expandoBridge.setAttributes(serviceContext);
    }

    @Override
    public VehicleTypeResource toEscapedModel() {
        if (_escapedModel == null) {
            _escapedModel = (VehicleTypeResource) ProxyUtil.newProxyInstance(_classLoader,
                    _escapedModelInterfaces, new AutoEscapeBeanHandler(this));
        }

        return _escapedModel;
    }

    @Override
    public Object clone() {
        VehicleTypeResourceImpl vehicleTypeResourceImpl = new VehicleTypeResourceImpl();

        vehicleTypeResourceImpl.setVehicleTypeResourceId(getVehicleTypeResourceId());
        vehicleTypeResourceImpl.setVehicleTypeId(getVehicleTypeId());
        vehicleTypeResourceImpl.setCountry(getCountry());
        vehicleTypeResourceImpl.setLanguage(getLanguage());
        vehicleTypeResourceImpl.setName(getName());
        vehicleTypeResourceImpl.setIconId(getIconId());

        vehicleTypeResourceImpl.resetOriginalValues();

        return vehicleTypeResourceImpl;
    }

    @Override
    public int compareTo(VehicleTypeResource vehicleTypeResource) {
        int value = 0;

        if (getVehicleTypeId() < vehicleTypeResource.getVehicleTypeId()) {
            value = -1;
        } else if (getVehicleTypeId() > vehicleTypeResource.getVehicleTypeId()) {
            value = 1;
        } else {
            value = 0;
        }

        if (value != 0) {
            return value;
        }

        value = getCountry()
                    .compareToIgnoreCase(vehicleTypeResource.getCountry());

        if (value != 0) {
            return value;
        }

        value = getLanguage()
                    .compareToIgnoreCase(vehicleTypeResource.getLanguage());

        if (value != 0) {
            return value;
        }

        return 0;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }

        if (!(obj instanceof VehicleTypeResource)) {
            return false;
        }

        VehicleTypeResource vehicleTypeResource = (VehicleTypeResource) obj;

        long primaryKey = vehicleTypeResource.getPrimaryKey();

        if (getPrimaryKey() == primaryKey) {
            return true;
        } else {
            return false;
        }
    }

    @Override
    public int hashCode() {
        return (int) getPrimaryKey();
    }

    @Override
    public void resetOriginalValues() {
        VehicleTypeResourceModelImpl vehicleTypeResourceModelImpl = this;

        vehicleTypeResourceModelImpl._originalVehicleTypeId = vehicleTypeResourceModelImpl._vehicleTypeId;

        vehicleTypeResourceModelImpl._setOriginalVehicleTypeId = false;

        vehicleTypeResourceModelImpl._originalCountry = vehicleTypeResourceModelImpl._country;

        vehicleTypeResourceModelImpl._originalLanguage = vehicleTypeResourceModelImpl._language;

        vehicleTypeResourceModelImpl._columnBitmask = 0;
    }

    @Override
    public CacheModel<VehicleTypeResource> toCacheModel() {
        VehicleTypeResourceCacheModel vehicleTypeResourceCacheModel = new VehicleTypeResourceCacheModel();

        vehicleTypeResourceCacheModel.vehicleTypeResourceId = getVehicleTypeResourceId();

        vehicleTypeResourceCacheModel.vehicleTypeId = getVehicleTypeId();

        vehicleTypeResourceCacheModel.country = getCountry();

        String country = vehicleTypeResourceCacheModel.country;

        if ((country != null) && (country.length() == 0)) {
            vehicleTypeResourceCacheModel.country = null;
        }

        vehicleTypeResourceCacheModel.language = getLanguage();

        String language = vehicleTypeResourceCacheModel.language;

        if ((language != null) && (language.length() == 0)) {
            vehicleTypeResourceCacheModel.language = null;
        }

        vehicleTypeResourceCacheModel.name = getName();

        String name = vehicleTypeResourceCacheModel.name;

        if ((name != null) && (name.length() == 0)) {
            vehicleTypeResourceCacheModel.name = null;
        }

        vehicleTypeResourceCacheModel.iconId = getIconId();

        return vehicleTypeResourceCacheModel;
    }

    @Override
    public String toString() {
        StringBundler sb = new StringBundler(13);

        sb.append("{vehicleTypeResourceId=");
        sb.append(getVehicleTypeResourceId());
        sb.append(", vehicleTypeId=");
        sb.append(getVehicleTypeId());
        sb.append(", country=");
        sb.append(getCountry());
        sb.append(", language=");
        sb.append(getLanguage());
        sb.append(", name=");
        sb.append(getName());
        sb.append(", iconId=");
        sb.append(getIconId());
        sb.append("}");

        return sb.toString();
    }

    @Override
    public String toXmlString() {
        StringBundler sb = new StringBundler(22);

        sb.append("<model><model-name>");
        sb.append("de.humance.eco.profile.model.VehicleTypeResource");
        sb.append("</model-name>");

        sb.append(
            "<column><column-name>vehicleTypeResourceId</column-name><column-value><![CDATA[");
        sb.append(getVehicleTypeResourceId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>vehicleTypeId</column-name><column-value><![CDATA[");
        sb.append(getVehicleTypeId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>country</column-name><column-value><![CDATA[");
        sb.append(getCountry());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>language</column-name><column-value><![CDATA[");
        sb.append(getLanguage());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>name</column-name><column-value><![CDATA[");
        sb.append(getName());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>iconId</column-name><column-value><![CDATA[");
        sb.append(getIconId());
        sb.append("]]></column-value></column>");

        sb.append("</model>");

        return sb.toString();
    }
}
